using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using Exferia_Mythos._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;

namespace Exferia_Mythos._3_Vistas
{
    public partial class P_Parte_ProtocoloRelleno : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_Parte_ProtocoloRelleno_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_Tipo { get { return ex_cbo_P_Parte_ProtocoloRelleno_Tipo; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_Protocolo { get { return ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo; } }
        internal Exferia_F3 Exferia_F3_Tecnico { get { return ex_usc_F3_P_Parte_ProtocoloRelleno_Tecnico; } }
        internal Exferia_F3 Exferia_F3_Terminal { get { return ex_usc_F3_P_Parte_ProtocoloRelleno_Terminal; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Tipo { get { return ex_lbl_P_Parte_ProtocoloRelleno_Tipo; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_ParteProtocolosRellenos { get { return ex_Paginador; } }

        //Panel
        internal Panel Panel_Preguntas { get { return pnl_P_Parte_ProtocoloRelleno_Preguntas; } }

        #endregion

        #region Constructor
        public P_Parte_ProtocoloRelleno(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                    DateTime _dtt_FechaTrabajo,
                                    PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle,
                                    INTERNO_MYT_Partes_Modelo _mdl_INTERNO_MYT_Partes_Modelo)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_Parte_ProtocoloRelleno_Controladora(this, _mdl_INTERNO_MYT_Partes_Modelo);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura ..........................
                ex_btn_P_Parte_ProtocoloRelleno_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_Parte_ProtocoloRelleno_Grabar.Exferia_Button_Bloqueable = false;
                //.................................................................................................

                //Datos de la Cabecera
                ex_lbl_P_Parte_ProtocoloRelleno_Resumen.Text = "(" + _mdl_INTERNO_MYT_Partes_Modelo.codigo + ") ";

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Parte_ProtocoloRelleno) + "/" + nameof(P_Parte_ProtocoloRelleno));
                    }
                }
                //....................................................................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                //PROTOCOLO
                ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_PROTOCOLOS;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;

                //TECNICO
                ex_usc_F3_P_Parte_ProtocoloRelleno_Tecnico.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_TECNICOS;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Tecnico.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Tecnico.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;

                //TERMINAL
                ex_usc_F3_P_Parte_ProtocoloRelleno_Terminal.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_TERMINALES;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Terminal.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Parte_ProtocoloRelleno_Terminal.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Parte_ProtocoloRelleno) + "/" + nameof(P_Parte_ProtocoloRelleno));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto ....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Parte_ProtocoloRelleno_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION 
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
                #endregion
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Parte_ProtocoloRelleno) + "/" + nameof(P_Parte_ProtocoloRelleno_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_Parte_ProtocoloRelleno_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        Funciones.Poner_Foco_Objeto(this, ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo.Exferia_F3_PRINCIPAL_TextBox_Codigo);

                        P_Base_SeModificoDatosPantalla = false;
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            ex_Paginador.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            ex_Paginador.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Parte_ProtocoloRelleno) + "/" + nameof(P_Parte_ProtocoloRelleno_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (ex_Paginador.Visible)
            {
                ex_Paginador.Visible = _bol_Activar;
            }

            if (ex_btn_P_Parte_ProtocoloRelleno_Borrar.Enabled)
            {
                ex_btn_P_Parte_ProtocoloRelleno_Borrar.Enabled = _bol_Activar;
            }
        }

        #endregion

        #region Botones Grabar, Borrar 
        private void ex_btn_P_Parte_ProtocoloRelleno_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (g_obj_Controladora.g_bol_Traspasado)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_PARTES_NOSEPUEDEMODIFICAR_ESTATRASPASADP());
            }
            else
            {
                if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
                {
                    //Añadiendo
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        g_obj_Controladora.GrabarDatos(true);
                    }
                    //Modificando
                    else
                    {
                        g_obj_Controladora.GrabarDatos(false);
                    }
                }
            }
        }

        private void ex_btn_P_Parte_ProtocoloRelleno_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (g_obj_Controladora.g_bol_Traspasado)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_PARTES_NOSEPUEDEMODIFICAR_ESTATRASPASADP());
            }
            else
            {
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
                {
                    g_obj_Controladora.BorrarDatos();
                }
            }

        }

        #endregion

        #region Protocolo
        private void ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if (g_obj_Controladora!=null)
            {
                g_obj_Controladora.Protocolo_Crear(ex_usc_F3_P_Parte_ProtocoloRelleno_Protocolo.Exferia_F3_Id,false);
            }
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }
        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatosInicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempospasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_ParteProtocolosRellenos.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        private void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_ParteProtocolosRellenos.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_ParteProtocolosRellenos.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_ParteProtocolosRellenos.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempos pasamos a la pagina indicada
                {
                    //Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_ParteProtocolosRellenos.txt_ValorPaginaActual - 1);

                    //Asignamos al control la pagina actual
                    Exferia_Paginador_ParteProtocolosRellenos.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Regrescamos el listad a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }

            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        
    }
}
